<?php

namespace Drupal\creditreform\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Provides a Creditreform form.
 */
class GetReportForm extends FormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'creditreform_get_report';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {

    $form['crefo_id'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Crefo ID'),
      '#required' => TRUE,
    ];

    $form['actions'] = [
      '#type' => 'actions',
    ];
    $form['actions']['submit'] = [
      '#type' => 'submit',
      '#value' => $this->t('Send'),
    ];

    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    if (mb_strlen($form_state->getValue('crefo_id')) < 9) {
      $form_state->setErrorByName('crefo_id', $this->t('CrefoID should be at least 9 characters.'));
    }
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $creditreform_api = \Drupal::service('creditreform.api');
    $result = $creditreform_api->getReport($form_state->getValue('crefo_id'));
    $this->messenger()->addStatus((json_encode($result)));
  }

}
